



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spark 1.6升级2.x防踩坑指南</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spark 1.6升级2.x防踩坑指南</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 00:31:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>原创文章，谢绝转载</p></blockquote>
<p>Spark 2.x自2.0.0发布到目前的2.2.0已经有一年多的时间了，2.x宣称有诸多的性能改进，相信不少使用Spark的同学还停留在1.6.x或者更低的版本上，没有升级到2.x或许是由于1.6相对而言很稳定，或许是升级后处处踩坑被迫放弃。</p>
<p>Spark SQL是Spark中最重要的模块之一，基本上Spark每个版本发布SQL模块都有不少的改动，而且官网还会附带一个<a href="http://spark.apache.org/docs/latest/sql-programming-guide.html#migration-guide" rel="external nofollow noreferrer">Migration Guide</a>帮忙大家升级。问题在于Migration Guide并没有详尽的列出所有变动，本文以SQL模块为主，扒一扒Spark升级2.x过程中可能会踩到的坑。</p>
<h2>计算准确性</h2>
<blockquote><p>那些升级后，让你感到心中有千万只草泥马奔腾而过的问题</p></blockquote>
<ul><li><code>SELECT '0.1' = 0</code>返回的是true！Spark 2.2中，0.1会被转换为int，如果你的数据类型全部是文本类型，做数值计算时，结果极有可能不正确。之前的版本中0.1会被转换为double类型绝大多数场景下这样的处理是正确的。目前为止，社区还没有很好的处理这个问题，针对这个问题，我给社区提交过一个PR，想要自己解决这个问题的同学，可以手动合并下：<a href="https://github.com/apache/spark/pull/18986" rel="external nofollow noreferrer">https://github.com/apache/spark/pull/18986</a></li>
<li>过于复杂的SQL语句执行可能会出现64KB字节码编译限制的问题，这算是个老问题了，Spark自从上了Tungsten基本上一直存在这个问题，也算是受到了JVM的限制，遇到此类问题，建议大家找找PR：<a href="https://github.com/apache/spark/search?utf8=%E2%9C%93&amp;q=64KB&amp;type=Issues" rel="external nofollow noreferrer">https://github.com/apache/spark/search?utf8=%E2%9C%93&amp;q=64KB&amp;type=Issues</a></li>
<li>数据计算精度有问题，<code>SELECT 1 &gt; 0.0001</code>会报错，这个问题已在2.1.2及2.2.0中修复：<a href="https://issues.apache.org/jira/browse/SPARK-20211" rel="external nofollow noreferrer">https://issues.apache.org/jira/browse/SPARK-20211</a></li>
<li>2.1.0版本中<code>INNER JOIN</code>涉及到常量计算结果不正确，后续版本已修复：<a href="https://issues.apache.org/jira/browse/SPARK-19766" rel="external nofollow noreferrer">https://issues.apache.org/jira/browse/SPARK-19766</a></li>
<li>2.1.0中，执行<code>GROUPING SET(col)</code>，如果col列数据为null，会报空指针异常，后续版本已修复：<a href="https://issues.apache.org/jira/browse/SPARK-19509" rel="external nofollow noreferrer">https://issues.apache.org/jira/browse/SPARK-19509</a></li>
<li>2.1.0中，嵌套的CASE WHEN语句执行有可能出错，后续版本已修复：<a href="https://issues.apache.org/jira/browse/SPARK-19472" rel="external nofollow noreferrer">https://issues.apache.org/jira/browse/SPARK-19472</a></li></ul>
<h2>行为变化</h2>
<blockquote><p>那些不算太致命，改改代码或配置就可以兼容的问题。</p></blockquote>
<ul><li>Spark 2.2的UDAF实现有所变动，如果你的Hive UDAF没有严格按照标准实现，有可能会计算报错或数据不正确，建议将逻辑迁移到Spark AF，同时也能获得更好的性能</li>
<li>Spark 2.x限制了Hive表中<code>spark.sql.*</code>相关属性的操作，明明存在的属性，使用<code>SHOW TBLPROPERTIES tb(&quot;spark.sql.sources.schema.numParts&quot;)</code>无法获取到，同理也无法执行<code>ALTER TABLE tb SET TBLPROPERTIES ('spark.sql.test' = 'test')</code>进行修改</li>
<li>无法修改外部表的属性<code>ALTER TABLE tb SET TBLPROPERTIES ('test' = 'test')</code>这里假设tb是EXTERNAL类型的表</li>
<li>DROP VIEW IF EXISTS tb，如果这里的tb是个TABLE而非VIEW，执行会报错<code>AnalysisException: Cannot drop a table with DROP VIEW</code>，在2.x以下不会报错，由于我们指定了IF EXISTS关键字，这里的报错显然不合理，需要做异常处理。</li>
<li>如果你访问的表不存在，异常信息在Spark2.x里由之前的<code>Table not found</code>变成了<code>Table or view not found</code>，如果你的代码里依赖这个异常信息，就需要注意调整了。</li>
<li>EXPLAIN语句的返回格式变掉了，在1.6里是多行文本，2.x中是一行，而且内容格式也有稍微的变化，相比Spark1.6，少了Tungsten关键字；EXPLAIN中显示的HDFS路径过长的话，在Spark 2.x中会被省略为...</li>
<li>2.x中默认不支持笛卡尔积操作，需要通过参数<code>spark.sql.crossJoin.enabled</code>开启</li>
<li>OLAP分析中常用的<code>GROUPING__ID</code>函数在2.x变成了<code>GROUPING_ID()</code></li>
<li>如果你有一个基于Hive的UDF名为abc，有3个参数，然后又基于Spark的UDF实现了一个2个参数的abc，在2.x中，2个参数的abc会覆盖掉Hive中3个参数的abc函数，1.6则不会有这个问题</li>
<li>执行类似<code>SELECT 1 FROM tb GROUP BY 1</code>的语句会报错，需要单独设置<code>spark.sql.groupByOrdinal false</code>类似的参数还有<code>spark.sql.orderByOrdinal false</code></li>
<li>CREATE DATABASE默认路径发生了变化，不在从hive-site.xml读取<code>hive.metastore.warehouse.dir</code>，需要通过Spark的<code>spark.sql.warehouse.dir</code>配置指定数据库的默认存储路径。</li>
<li>CAST一个不存在的日期返回null，如：year('2015-03-40')，在1.6中返回2015</li>
<li>Spark 2.x不允许在VIEW中使用临时函数（temp function）<a href="https://issues.apache.org/jira/browse/SPARK-18209" rel="external nofollow noreferrer">https://issues.apache.org/jira/browse/SPARK-18209</a></li>
<li>Spark 2.1以后，窗口函数ROW_NUMBER()必须要在OVER内添加ORDER BY，以前的<code>ROW_NUMBER() OVER()</code>执行会报错</li>
<li>Spark 2.1以后，<code>SIZE(null)</code>返回-1，之前的版本返回null</li>
<li>Parquet文件的默认压缩算法由gzip变成了snappy，据官方说法是snappy有更好的查询性能，大家需要自己验证性能的变化</li>
<li>DESC FORMATTED tb返回的内容有所变化，1.6的格式和Hive比较贴近，2.x中分两列显示</li>
<li>异常信息的变化，未定义的函数，Spark 2.x: <code>org.apache.spark.sql.AnalysisException: Undefined function: 'xxx’.</code>, Spark 1.6: <code>AnalysisException: undefined function xxx</code>，参数格式错误：Spark 2.x:<code>Invalid number of arguments</code>, Spark 1.6: <code>No handler for Hive udf class org.apache.hadoop.hive.ql.udf.generic.GenericUDAFXXX because: Exactly one argument is expected..</code></li>
<li>Spark Standalone的WebUI中已经没有这个API了：<code>/api/v1/applications</code>：<a href="https://issues.apache.org/jira/browse/SPARK-12299" rel="external nofollow noreferrer">https://issues.apache.org/jira/browse/SPARK-12299</a>，<a href="https://issues.apache.org/jira/browse/SPARK-18683" rel="external nofollow noreferrer">https://issues.apache.org/jira/browse/SPARK-18683</a></li></ul>
<h2>版本回退</h2>
<blockquote><p>那些升级到2.x后，发现有问题回退后，让你欲哭无泪的问题。</p></blockquote>
<ul><li>Spark 2.0开始，SQL创建的分区表兼容Hive了，Spark会将分区信息保存到HiveMetastore中，也就是我们可以通过SHOW PARTITIONS查询分区，Hive也能正常查询这些分区表了。如果将Spark切换到低版本，在更新分区表，HiveMetastore中的分区信息并不会更新，需要执行<code>MSCK REPAIR TABLE</code>进行修复，否则再次升级会出现缺数据的现象。</li>
<li>Spark 2.0 ~ 2.1创建的VIEW并不会把创建VIEW的原始SQL更新到HiveMetastore，而是解析后的SQL，如果这个SQL包含复杂的子查询，那么切换到1.6后，就有可能无法使用这个VIEW表了（1.6对SQL的支持不如2.x）</li></ul>
<h2>其他</h2>
<p>从2.2.0开始，Spark不在支持Hadoop 2.5及更早的版本，同时也不支持Java 7 了，所以，如果你用的版本比较老，还是尽快升级的比较好。</p>
<p>2.x中对于ThriftServer或JobServer这样的长时间运行的服务，稳定性不如1.6，如果您的计算业务复杂、SQL计算任务繁多、频繁的更新数据、处理数据量较大，稳定性的问题更加凸显。稳定性问题主要集中在内存方面，Executor经常出现堆外内存严重超出、OOM导致进程异常退出等问题。Executor进程OOM异常退出后相关的block-mgr目录（也就是SPARK_LOCAL_DIRS）并不会被清理，这就导致Spark Application长时间运行很容易出现磁盘被写满的情况。</p>
<h2>总结</h2>
<p>Spark 2.x中为了性能，SQL模块的改动相当大，这也导致Bug变多，稳定性变差。当然，随着Spark的不断改进迭代，这些问题也在逐步缓解。</p>
<p>对于一个计算服务，相比性能，数据计算的正确性及稳定性更加重要。建议尚未升级到2.x的同学，最好使用最新的Spark版本做升级；升级前，务必结合自己的业务场景做好充分的测试，避免踩坑。</p>
<p><img referrerpolicy="no-referrer"src="http://images.stanzhai.site/bigdata-spark.jpg" /></p>
<p>本文同步更新到微信公众号，欢迎扫码关注。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k14wr9.html">菜鸟git学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q25jmxq.html">WDM驱动加载方式理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g4l749.html">移动端js写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyxx3m8.html">python 生成器和递归</a>
		</li>
						<li><a href="https://www.batexi.com/a/390nz33q.html">【python】id&lpar;&rpar;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn35329.html">UML基础：统一建模语言简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m23xeq.html">Poj 2262 &sol; OpenJudge 2262 Goldbach&amp;&num;39&semi;s Conjecture</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnv4zq.html">1089-Duplicate Removal</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjeeok9.html">HDOJ-ACM1016&lpar;JAVA&rpar; 字典序全排列，并剪枝</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejgz48.html">C语言缓冲区清空</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy14xpjq.html">FB面经 Prepare&colon; Task Schedule</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp5e6j9.html">老李谈HTTP1&period;1的长连接 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpgwyvq.html">Spring Security学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey7gkz9.html">iOS开发--XMPPFramework--好友列表（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95023yv8.html">ActiveMQ简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w74rnq.html">bzoj4361 isn（树状数组优化dp&plus;容斥）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx5n28.html">Object&lowbar;C 与JavaScript交互使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2x4mo9.html">【npm】详解npm的模块安装机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emml1z9.html">POJ 3126 --Father Christmas flymouse【scc缩点构图 &amp;amp&semi;amp&semi;&amp;amp&semi;amp&semi; SPFA求最长路】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e05r0mq.html">Luogu P3258 松鼠的新家（树链剖分&plus;线段树&sol;树状数组）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2j3nyw8.html">web正则表达式与示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojypylq.html">fiddler 抓取手机app请求包</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pd2138.html">ue4&lpar;c&plus;&plus;&rpar; 按钮中的文字居中的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zd1pk9.html">Vue模板逻辑</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1kmeyq.html">css中的几个小tip（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gegvz48.html">安徽省2016&OpenCurlyDoubleQuote;京胜杯&rdquo;程序设计大赛&lowbar;C&lowbar;箭无虚发</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gegv0z8.html">初学Python之 字符串 索引 分片</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gegvyz8.html">Android Studio 或 IntelliJ IDEA获取数字签名的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mek5lrq.html">&lbrack;STL&rsqb; SET实用用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpkynjq.html">EF对于已有数据库的Code First支持</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
